﻿/**
	FunctionQueue class
	JDG Communications for Federal Trade Commission
*/

//import com.gaiaframework.debug.*;

class gov.ftc.core.FunctionQueue
{
	private var __fQueue:Array;
	private var __waitInterval:Number;
	
	public function FunctionQueue() {
		this.__fQueue = [];
	}
	
	public function add(scope:Object, functName:String, parms:Object, immed:Boolean):Number {
		// immed:Boolean  - if true, executes run() immediately, calling the next queued function
//		trace('FunctionQueue.add: ' + functName);
		var functObject:Object = {s:scope, f:functName, p:parms, i:immed};
		__fQueue.push(functObject);
		return __fQueue.length;
	}
	
	public function addWait(waitTime:Number):Number {
		var functObject:Object = {w:waitTime};
		__fQueue.push(functObject);
		return __fQueue.length;
	}
	
	public function run(p_caller:String):Void {
//		GaiaDebug.log("FunctionQueue.run", p_caller);
		if (__fQueue.length) {
			var args:Object = __fQueue.shift();
			if (args.w != undefined && !isNaN(args.w)) {
				this.__waitInterval = setInterval(this, 'cancelWait', args.w);
			} else {
				var scope:Object = args.s;
				var functName:String = args.f;
				var parms:Array = args.p;
//				trace('FunctionQueue calling ' + functName);
				scope[functName].apply(scope, parms);
				if (args.i) {
					run();
				}
			}
		}
	}
	
	public function remove(pos:Number):Boolean {
//		trace('FunctionQueue.remove: ' + __fQueue[pos-1].functName);
		return delete __fQueue[pos-1];
	}
	
	public function cancelWait():Void {
//		trace('FunctionQueue.cancelWait');
		clearInterval(__waitInterval);
		run();
	}
	
	public function flush():Void {
		clearInterval(__waitInterval);
		this.__fQueue = [];
	}
	
	public function destroy():Void {
		flush();
	}
}
