/**
	GameData class
	JDG Communications for Federal Trade Commission
*/

class gov.ftc.squaresgame.GameData extends Object {

// CLASS VARIABLES
	private var __gc:MovieClip;

	public var gameScore:Object;
	
	public var gameController:Object;
	public var backgroundDisplay:Object;
	public var character:Object;
	public var soundManager:Object;
	public var displayManager:Object;
	public var questionDisplay:Object;
	public var scoreManager:Object;
	public var gameBoardDisplay:Object;
	
// CONSTRUCTOR

	public function GameData() {
		super();
		__gc = _global.squaresgameGC;
		init();
	}

	
// CLASS METHODS

	public function init():Void {
	
		_global.squaresgameGD = this;
	
		gameController = {
			gamePhase: null,
			correctAnswers: [
				"agree", // 0
				"disagree", // 1
				"agree", // 2
				"agree", // 3
				"disagree", // 4
				"disagree", // 5
				"disagree", // 6
				"disagree", // 7
				"disagree", // 8
				"disagree", // 9
				"disagree", // 10
				"disagree" // 11
			],
			infoUrl: "http://www.onguardonline.gov",

			startTurnFlashBorderDelay: 1,
			startTurnPlaySoundDelay: 1,
			startTurnBeginQuestionDelay: 2.5,
			startTurnShowHostPromptDelay: .1,

			clickCharacterBeginQuestionDelay: 1.3,
			
			playLaughDelay: 0.5,
			
			showOpponentAnswerDelay: 3.3,
			afterOpponentAnswerDelay: .5,
			
			endQuestionTurnDelayMark: .75,
			endQuestionTurnDelayMiss: 3,
			endQuestionFadeLoopDelay: .5,
			endQuestionFadeLoopDuration: .5,
			endQuestionStopLoopDelay: 1.1,
			endQuestionPlayEndsoundDelay: .5
		};

		backgroundDisplay = {};
		
		soundManager = {
			sounds: {
				applause1: { src: "applause1.aif" },
				applause2: { src: "applause2.aif" },
				chime1: { src: "chime1.aif" },
				chime2: { src: "chime2.aif" },
				chime3: { src: "chime3.aif" },
				end_mix01: { src: "end_mix01.aif" },
				groan1: { src: "groan1.aif" },
				groan2: { src: "groan2.aif" },
				laugh1: { src: "laugh1.aif" },
				laugh2: { src: "laugh2.aif" },
				laugh3: { src: "laugh3.aif" },
				laugh4: { src: "laugh4.aif" },
				loop_mix1: { src: "loop_mix1.aif" }
			}
		};
		
		questionDisplay = {
//			answer1delay: 3,
			answer1delay: 6,
			opponentAnswerDelay: 0.1,
//			opponentAnswerDelay: 1,
			afterOpponentAnswerDelay: .5,
			crossFadeDelay: 0.4
		}
		
		displayManager = {};
		
		scoreManager = {};
		
		character = {
			borderColors: {
				idle: 0xB7E1D8,
				rolloverX: 0xE4EB8D,
				rolloverO: 0xEFBD80,
				markedX: 0xD5E04E,
				markedO: 0xff8016
			},
			borderFlashRate: 0.3
		};
		
		gameBoardDisplay = {
			showWinFlashDuration: 3
		}
		
	}
	
	public function newGame():Void {
		gameController.gameGrid = [0,0,0,0,0,0,0,0,0],
		gameController.extraQuestionsUsed = [0, 0, 0],
		gameController.currentTurn = 1,
		gameController.currentQuestion = null,
		gameController.currentCharacter = null,
		gameController.lastAnswerCorrect = null,
		gameController.winner = null
	}
}