/**
	GameLoader class
	JDG Communications for Federal Trade Commission
*/

import mx.utils.Delegate;
import gs.TweenLite;

class gov.ftc.squaresgame.GameLoader extends MovieClip {

// CLASS VARIABLES

	private var __loader:MovieClipLoader;
	private var __listener:Object;
	
	public var loadProgress:MovieClip;
	public var xo_bg:MovieClip;
	
	public var clipToLoad:String;
	public var mc:MovieClip;
	
	private var __intervalId:Number

// CONSTRUCTOR
	
	public function GameLoader() {
		super();

		clipToLoad = "healthquiz_es.swf";
		
		mc = createEmptyMovieClip("mc", 1);

		__listener = new Object();

		__loader = new MovieClipLoader();
		__loader.addListener(__listener);
		__loader.loadClip(clipToLoad, mc);
		
		__listener.onLoadProgress = Delegate.create(this, doUpdate);
		__listener.onLoadComplete = Delegate.create(this, doLoadComplete);

	}
	
// CLASS METHODS

	public function doLoadComplete():Void {

		TweenLite.to(xo_bg, 1, {autoAlpha: 0});
		TweenLite.to(loadProgress, 1, {autoAlpha: 0, onComplete:Delegate.create(this, startGame)});
		
//		if not using TweenLite:

//		loadProgress._visible = false;
//		__intervalId = setInterval(this, "startGame", 200);

	}
	
	private function startGame():Void {

//		if not using TweenLite:

//		clearInterval(__intervalId);

		mc.init();
	}

	public function doUpdate(mc:MovieClip, loadedBytes:Number, totalBytes:Number):Void {
		var pct = Math.floor((loadedBytes/totalBytes) * 100);
		loadProgress.loadPct.text = String(pct) + "%";
	}
	
	public function destroy():Void {
		__loader.removeListener(__listener);
		TweenLite.killTweensOf(loadProgress);
	}
	
}