/**
	QuestionDisplay class
	JDG Communications for Federal Trade Commission
*/

import mx.utils.Delegate;

import gs.TweenLite;

import gov.ftc.core.Utilities;
import gov.ftc.core.FunctionDelay;

import gov.ftc.squaresgame.templates.DisplayClip;

class gov.ftc.squaresgame.QuestionDisplay extends DisplayClip {

// CLASS VARIABLES

// CONSTRUCTOR
	
	public function QuestionDisplay() {
		super();
		setData("questionDisplay");
	}
	
// CLASS METHODS


	public function init(p_questionNum:Number, p_currentTurn:Number):Void {

		mc = this.attachMovie("question"+p_questionNum, "mc", 1);
		mc._x = 0;
		mc._y = 0;
		mc.blendMode = "layer";
		TweenLite.to(mc.question, 0, {autoAlpha: 0, _xscale: 25, _yscale: 25});
		TweenLite.to(mc.answer1, 0, {autoAlpha: 0, _xscale: 25, _yscale: 25});
		TweenLite.to(mc.answer2, 0, {autoAlpha: 0, _xscale: 25, _yscale: 25});
		TweenLite.to(mc.expAgree, 0, {autoAlpha: 0, _xscale: 25, _yscale: 25});
		TweenLite.to(mc.expDisagree, 0, {autoAlpha: 0, _xscale: 25, _yscale: 25});
		FunctionDelay.callDelayed(this, "begin", 50, null);
	}
	
	private function begin(p_currentTurn:Number):Void {
		displayItem(mc.question, true);
/*		if (p_currentTurn == 1) {
			displayItem(mc.answer1, true, __gd.answer1delay);
		} else {
			mc.question.btnContinue.blink(true);
		}
*/
	}
	
	public function showStage(p_stage:String, p_currentTurn:Number):Void {
		var delay:Number = (p_currentTurn == 1) ? 0 : __gd.opponentAnswerDelay;
		var delay2:Number = (p_currentTurn == 1) ? 0 : __gd.afterOpponentAnswerDelay;
		var opponentAnswerFrame:Number;
		switch (p_stage) {
			case "answer1": // added to Spanish quiz
				displayItem(mc.answer1, true, 0);
				mc.question.btnContinue.blink(false);
				mc.question.btnContinue.active = false;
				mc.question.btnContinue._alpha = 30;
				break;
			case "answer2":
				if (p_currentTurn == 2) {
					mc.answer2.btnAgree._visible = false;
					mc.answer2.btnDisagree._visible = false;
					mc.answer2.attachMovie("computerStatus", "opponentAnswer", 1);
					mc.answer2.opponentAnswer._x = mc.answer2.btnAgree._x;
					mc.answer2.opponentAnswer._y = mc.answer2.btnAgree._y;
				}
				displayItem(mc.answer1, false);
				displayItem(mc.answer2, true, __gd.crossFadeDelay);
				break;
			case "agree":
				mc.answer2.btnAgree.active = false;
				mc.answer2.btnDisagree.active = false;
				mc.answer2.btnDisagree._alpha = 30;
				opponentAnswerFrame = 2;
				displayItem(mc.question, false, delay + delay2);
				displayItem(mc.expAgree, true, delay + __gd.crossFadeDelay);
				mc.expAgree.btnContinue.blink(true);
				break;
			case "disagree":
				mc.answer2.btnAgree.active = false;
				mc.answer2.btnDisagree.active = false;
				mc.answer2.btnAgree._alpha = 30;
				opponentAnswerFrame = 3;
				displayItem(mc.question, false, delay + delay2);
				displayItem(mc.expDisagree, true, delay + __gd.crossFadeDelay);
				mc.expDisagree.btnContinue.blink(true);
		}
		if (delay > 0) FunctionDelay.callDelayed(mc.answer2.opponentAnswer, "gotoAndStop", delay*1000, [opponentAnswerFrame]);
	}
	
	public function end():Void {
		displayItem(mc.question, false);
		displayItem(mc.answer1, false);
		displayItem(mc.answer2, false);
		displayItem(mc.expAgree, false);
		displayItem(mc.expDisagree, false);
		FunctionDelay.callDelayed(this, "killQuestion", 400, null);
	}
	
	public function killQuestion():Void {
		mc.removeMovieClip();
		__gc.gameBroadcaster.broadcastMessage("questionDoneEvent");
	}
	
	private function displayItem(p_mc:MovieClip, p_mode:Boolean, p_delay:Number):Void {
		var tweenVars:Object = {autoAlpha: 0, _xscale: 25, _yscale: 25};
		if (p_mode == true) tweenVars = { 
			autoAlpha: 100,
			_xscale: 100,
			_yscale: 100,
			onComplete: Delegate.create(this, notifyGcItemDone),
			onCompleteParams: [p_mc._name]
		};
		if (p_delay > 0) tweenVars.delay = p_delay;
		TweenLite.to(p_mc, 0.3, tweenVars);
	}
	
	private function notifyGcItemDone(p_mcName:String):Void {
//		trace("QuestionDisplay.notifyGcItemDone: " + p_mcName);
		__gc.gameBroadcaster.broadcastMessage("questionItemDisplayDoneEvent", p_mcName);
	}

	public function destroy():Void {
		this.onEnterFrame = null;
		TweenLite.killTweensOf(mc);
	}
	
}